Remove Element

Given an array nums _and a value _val, remove all instances of that value in-place and return the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

The order of elements can be changed. It doesn't matter what you leave beyond the new length.

Example 1:

Given nums = [3,2,2,3], val = 3,

Your function should return length = 2, with the first two elements of nums being 2.

It doesn't matter what you leave beyond the returned length.

Example 2:

Given nums = [0,1,2,2,3,0,4,2], val = 2,

Your function should return length = 5, with the first five elements of nums containing 0, 1, 3, 0, and 4.

Note that the order of those five elements can be arbitrary.

It doesn't matter what values are set beyond the returned length.

Clarification:

Confused why the returned value is an integer but your answer is an array?

Note that the input array is passed in by reference, which means modification to the input array will be known to the caller as well.

Internally you can think of this:

// nums is passed in by reference. (i.e., without making a copy)
int len = removeElement(nums, val);

// any modification to nums in your function would be known by the caller.
// using the length returned by your function, it prints the first len elements.
for (int i = 0; i < len; i++) {
    print(nums[i]);
}

Analysis

Tricky在于In-place,返回的是长度length,相当于remove之后原始数组的下标边界。

Solution

Two Pointers - Swapping val - Time O(n) each element at most one time, Space O(1)

target val to remove is in [p, nums.length - 1]

class Solution {
    public int removeElement(int[] nums, int val) {
        if (nums == null || nums.length == 0) {
            return 0;
        }
        int p = 0, q = nums.length - 1;
        while (p < nums.length && q >= 0) {
            while (p < nums.length && nums[p] != val) p++;
            while (q >= 0 && nums[q] == val) q--;
            if (p < q) {
                swap(p, q, nums);
            } else {
                break;
            }
        }
        return p;
    }
    private void swap(int p, int q, int[] nums) {
        int tmp = nums[p];
        nums[p] = nums[q];
        nums[q] = tmp;
    }
}

Two Pointers - shrinking array length

class Solution {
    public int removeElement(int[] nums, int val) {
        int i = 0;
        int j = nums.length - 1;
        while (i < j + 1) {
            if (nums[i] == val) {
                nums[i] = nums[j];
                // reduce array size by one
                j--;
            } else {
                i++;
            }
        }
        return j + 1;
    }
}

Other Approaches

Two pointers - Copy nums[j] != val Not so efficient if the target value is rare in the array, since it unnecessarily copies all nums[j] != val

Time: O(n), Space: O(1) - Assume the array has a total of n elements, both i and j traverse at most n steps.

public int removeElement(int[] nums, int val) {
    int i = 0;
    for (int j = 0; j < nums.length; j++) {
        if (nums[j] != val) {
            nums[i] = nums[j];
            i++;
        }
    }
    return i;
}

Reference

https://leetcode.com/articles/remove-element/

Last updated